<?php

namespace App\Classes\Modules\PerfexCRM\Services;

use Illuminate\Support\Facades\Http;
use App\Classes\Exceptions\MalformedRequestException;
use App\Classes\Exceptions\ConnectionErrorException;
use Illuminate\Support\Facades\Log;

class FetchesPerfexCRMProject
{
    /**
     * @param string $projectName
     * @param string $clientId
     * @return null|object
     * @throws MalformedRequestException
     */
    public function execute(string $projectName, string $clientId) {
        try{
            $data = [
                'name' => $projectName,
                'clientid' => $clientId,
            ];

            $response = Http::asForm()->withHeaders([
                'authtoken' => config('perfexcrm.api_key')])
            ->post(config('perfexcrm.base_url').'/api/projects/bynameandclientid', $data);

            if($response->successful()){
                $data = $response->json();

                return (object) $data;
            }else{
                Log::error('FetchesPerfexCRMProject: '.$response);
                return null;
            }
        }
        catch(\Illuminate\Http\Client\ConnectionException $exception){
            $error = 'Failed to connect to CRM';
            throw new ConnectionErrorException($error, $exception->getMessage(), "", $exception->getTraceAsString());
        }
        catch(\Exception $exception){
            throw new MalformedRequestException('Unable to get correct response from Perfex CRM server: ' . $exception->getMessage());
        }
    }
}
